% Written by Dr. Seyedali Mirjalili
% www.alimirjalili.com
% To watch videos on this algorithm, enrol to my courses with 95% discount using the following links: 

% ************************************************************************************************************************************************* 
%  A course on "Optimization Problems and Algorithms: how to understand, formulation, and solve optimization problems": 
%  https://www.udemy.com/optimisation/?couponCode=MATHWORKSREF
% ************************************************************************************************************************************************* 
%  "Introduction to Genetic Algorithms: Theory and Applications" 
%  https://www.udemy.com/geneticalgorithm/?couponCode=MATHWORKSREF
% ************************************************************************************************************************************************* 


function [child1 , child2] = crossover_continious(parent1 , parent2, Pc, Problem)

child1.Gene = zeros(1,Problem.nVar);
child2.Gene = zeros(1,Problem.nVar);
for k = 1 : Problem.nVar
    beta = rand();
    child1.Gene(k) = beta .* parent1.Gene(k) + (1-beta)*parent2.Gene(k); 
    child2.Gene(k) = (1-beta) .* parent1.Gene(k) + beta*parent2.Gene(k);
    
    if child1.Gene(k) > Problem.ub(k) 
        child1.Gene(k)  =  Problem.ub(k);
    end
    if child1.Gene(k) < Problem.lb(k)
        child1.Gene(k) = Problem.lb(k);
    end
    
    if child2.Gene(k) > Problem.ub(k) 
        child2.Gene(k)  =  Problem.ub(k);
    end
    
    if child2.Gene(k) < Problem.lb(k)
        child2.Gene(k) = Problem.lb(k);
    end
end

R1 = rand();

if R1 <= Pc
    child1 = child1;
else
    child1 = parent1;
end

R2 = rand();

if R2 <= Pc
    child2 = child2;
else
    child2 = parent2;
end

end